#include "Jacobi.hh"
#include "alglin.hh"
#include <iostream>
#include <iomanip>

using Jacobi::valueType ;
using Jacobi::indexType ;

using namespace std ;

#define NRow 4
#define LDA  4
#define LDQ  4
#define LDAQ 4

int
main() {

  valueType Q[NRow*LDQ], AQ[NRow*LDAQ], Asaved[NRow*LDA] ;
  valueType A[NRow*LDA] = {
    4, 1, 1, 1,
    1, 4, 1, 1,
    1, 1, 4, 1,
    1, 1, 1, 4  
  } ;
  
  alglin::copy( NRow*LDA, A, 1, Asaved, 1) ;

  bool ok = Jacobi::Jacobi( NRow, A, LDA, Q, LDQ, 10E-12, 100000 ) ;

  cout << "\nDiagonalized matrix\n\n" ;
  for ( indexType i = 0 ; i < NRow ; ++i ) {
    for ( indexType j = 0 ; j < NRow ; ++j ) {
      cout << setw(10) << A[ i + LDA * j ] << ' ' ;
    }
    cout << '\n' ;
  } 
  
  cout << "\nEigenvectors\n" ;
  cout << '\n' ;

  for ( indexType i = 0 ; i < NRow ; ++i ) {
    for ( indexType j = 0 ; j < NRow ; ++j ) {
      cout << setw(10) << Q[ i + LDQ * j ] << ' ' ;
    }
    cout << '\n' ;
  } 

  alglin::gemm( "No Transpose", "No Transpose", NRow, NRow, NRow,
                1.0, Asaved,  LDA, 
                     Q,  LDQ,
                0.0, AQ, LDAQ ) ;

  alglin::gemm( "No Transpose", "No Transpose", NRow, NRow, NRow,
                1.0, Q,  LDQ, 
                     A,  LDA,
               -1.0, AQ, LDAQ ) ;

  cout << "\nResidual AQ - Q Lambda\n" ;
  cout << '\n' ;

  for ( indexType i = 0 ; i < NRow ; ++i ) {
    for ( indexType j = 0 ; j < NRow ; ++j ) {
      cout << setw(10) << AQ[ i + LDQ * j ] << ' ' ;
    }
    cout << '\n' ;
  } 

  return 0 ;
}
